> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://developers.awork.com/apiv1/project-members/post-project-update-project-member-by-project-id/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.awork.com/_mcp/server. # Updates a member of the specified project. POST https://api.awork.com/api/v1/projects/{projectId}/updateprojectmember Content-Type: application/json Changes the member's role or responsible status. The selected role must be available for the project's type, and only one responsible member is allowed. The user must be the project creator or have `project-master-data:manage` permission for the project. Reference: https://developers.awork.com/apiv1/project-members/post-project-update-project-member-by-project-id ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `projectId` (string, required) — The id of the project. ### Body (application/json) This endpoint expects a ProjectMemberForm. - `userId` (string, required) — The id of the member. - `projectRoleId` (string, required) — The id of the project role for this member. - `isResponsible` (boolean, optional) — Whether the user should be marked as responsible. ## Response ### 200 OK - `id` (string, optional) — The id of the project member entity. - `userId` (string, optional) — The id of the user who is this project member. - `firstName` (string, optional, nullable) — The first name of the user. - `lastName` (string, optional, nullable) — The last name of the user. - `hasImage` (boolean, optional, nullable) — Whether the user has an image. - `projectRoleId` (string, optional) — The project role of the project member. - `projectRoleName` (string, optional, nullable) — The project role name of the project member. - `isResponsible` (boolean, optional) — Whether the user is responsible for this project. - `isDeactivated` (boolean, optional) — Whether the user is deactivated. - `isExternal` (boolean, optional) — True if this entity is coming from an external workspace (awork Connect). ## Examples **Request** ```json { "userId": "123e4567-e89b-12d3-a456-426614174000", "projectRoleId": "123e4567-e89b-12d3-a456-426614174000" } ``` **Response** ```json { "id": "123e4567-e89b-12d3-a456-426614174000", "userId": "123e4567-e89b-12d3-a456-426614174000", "firstName": "Lisa", "lastName": "Smith", "hasImage": true, "projectRoleId": "123e4567-e89b-12d3-a456-426614174000", "projectRoleName": "Project Manager", "isResponsible": true, "isDeactivated": false, "isExternal": true } ``` **SDK Code** ```python import requests url = "https://api.awork.com/api/v1/projects/projectId/updateprojectmember" payload = { "userId": "123e4567-e89b-12d3-a456-426614174000", "projectRoleId": "123e4567-e89b-12d3-a456-426614174000" } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.awork.com/api/v1/projects/projectId/updateprojectmember'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"userId":"123e4567-e89b-12d3-a456-426614174000","projectRoleId":"123e4567-e89b-12d3-a456-426614174000"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.awork.com/api/v1/projects/projectId/updateprojectmember" payload := strings.NewReader("{\n \"userId\": \"123e4567-e89b-12d3-a456-426614174000\",\n \"projectRoleId\": \"123e4567-e89b-12d3-a456-426614174000\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.awork.com/api/v1/projects/projectId/updateprojectmember") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"userId\": \"123e4567-e89b-12d3-a456-426614174000\",\n \"projectRoleId\": \"123e4567-e89b-12d3-a456-426614174000\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.awork.com/api/v1/projects/projectId/updateprojectmember") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"userId\": \"123e4567-e89b-12d3-a456-426614174000\",\n \"projectRoleId\": \"123e4567-e89b-12d3-a456-426614174000\"\n}") .asString(); ``` ```php request('POST', 'https://api.awork.com/api/v1/projects/projectId/updateprojectmember', [ 'body' => '{ "userId": "123e4567-e89b-12d3-a456-426614174000", "projectRoleId": "123e4567-e89b-12d3-a456-426614174000" }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.awork.com/api/v1/projects/projectId/updateprojectmember"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"userId\": \"123e4567-e89b-12d3-a456-426614174000\",\n \"projectRoleId\": \"123e4567-e89b-12d3-a456-426614174000\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [ "userId": "123e4567-e89b-12d3-a456-426614174000", "projectRoleId": "123e4567-e89b-12d3-a456-426614174000" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.awork.com/api/v1/projects/projectId/updateprojectmember")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```